import { Fn } from '../types';
export declare const LEFT_TAG: unique symbol;
export declare const RIGHT_TAG: unique symbol;
export type Either<L, R> = ({
    readonly TAG: typeof LEFT_TAG;
    readonly value: L;
} | {
    readonly TAG: typeof RIGHT_TAG;
    readonly value: R;
}) & {
    fmap<U>(f: Fn<R, U>): Either<L, U>;
    apply<U>(f: Either<L, Fn<R, U>>): Either<L, U>;
    bind<U>(f: Fn<R, Either<L, U>>): Either<L, U>;
};
export declare const Left: <L, R = any>(x: L) => Either<L, R>;
export declare const Right: <R, L = any>(x: R) => Either<L, R>;
/**
 * Tells if the given value is a {@link Just} instance of Maybe.
 */
export declare function isLeft<L>(m: Either<L, any>): m is Either<L, any> & {
    TAG: typeof LEFT_TAG;
    value: L;
};
/**
 * Tells if the given value is a {@link Nothing} instance of Maybe.
 */
export declare function isRight<R>(m: Either<any, R>): m is Either<any, R> & {
    TAG: typeof RIGHT_TAG;
};
